; File:         Cons18.asm
; Author:       RuiLoureiro
; with a good hep from MichaelW (masm forum)
; ------------------------------------------
; Date:         14 /04 /2005
;
; Assembled in Quick Editor in Project -> Console Assemble & Link
; 
;                                   HOW and WHAT IT DOES
;
; We have 1 INPUT BUFFER and 1 SCREEN BUFFER
;
;                                                               FUNCTION
; 1  we get the INPUT BUFFER   HANDLE     _hInputBuffer      ( GetStdHandle )
; 2  we get the SCREEN BUFFER  HANDLE     _hScreenBuffer     ( GetStdHandle )
;-----------------------------------------------------------------------------
; Where\What is CONIO$ and CONOUT$ to use with CreateFile ?
; 
.486 
.model flat,stdcall 
option casemap:none 
; 
;                                       EQUATES
;
$LENINPUTRECORD   equ 18            ; length of each INPUT_RECORD
$MAXINPUTBUFFER   equ 40            ; 
; ---------------------------------------------------------------------------------------------
;                                       PROTOS
; format: Object + Action
;
;InfoGet          PROTO                              ; Gets  WindowScreen Info 
;ScreenBufferSet  PROTO  :DWORD                      ; Sets  ScreenBuffer
PASStrPrint      PROTO  :DWORD, :DWORD, :DWORD      ; pStr, Lin, Col
KeyWaitAny       PROTO                              ; wait for a key
CharRead         PROTO  :DWORD, :DWORD
KeyWait          PROTO
KeyPressed       PROTO  
RecordGet        PROTO    

;  *************** RCL functions ********************
RCLPrintLen      PROTO  :DWORD, :DWORD, :DWORD      ; pStr, Lin, Col
RCLPrintAll      PROTO  :DWORD, :DWORD, :DWORD      ; Print the entire string
RCLCleanMax      PROTO  :DWORD, :DWORD, :DWORD      ; pStr, Lin, Col
;
RCLEditStr       PROTO  :DWORD, :DWORD, :DWORD      ; Edit a RCL string
RCLAddBytAL      PROTO  :DWORD                      ; Add AL to RCL string 
RCLAddFulAL      PROTO  :DWORD, :DWORD              ; Add AL  
RCLCpyRCL        PROTO  :DWORD, :DWORD              ; Copy RCL to RCL 
RCLPutBytAL      PROTO  :DWORD, :DWORD              ; Put AL in RCL at IDX
RCLFilBytAL      PROTO  :DWORD                      ; Fill RCL with AL
RCLShlPos        PROTO  :DWORD, :DWORD              ; Shift left RCL to Pos
RCLClean         PROTO  :DWORD                      ; Clean RCL with spaces
RCLSetLen        PROTO                              ; Set string len field 
;------------------ Conversion functios -------------
DNatCnvRcl       PROTO  :DWORD                      ; convert natural number EAX
DHexCnvRcl	     PROTO  :DWORD                      ;    "    hexadecimal    EAX
DHexCnvBuf       PROTO  

EAXStkCnv        PROTO                              ; used in convertion
RCLStkCpy        PROTO                              ;   "         "
BufStkCpy        PROTO                              ;   "         "
; *************** CURSOR functions ******************
CursorSetPos     PROTO  :DWORD, :DWORD              ; Lin, Col
LCCurSet         PROTO  :DWORD, :DWORD              ; Lin, Col
;................ to show ...........................
PrintRecRead     PROTO
PrintNumRep      PROTO
PrintEventTyp    PROTO
PrintPresRel     PROTO
EventsUnRead     PROTO
PrintNumPR       PROTO
;----------------------------------------------------------------------------------------------
;                                       INCLUDES
;
include \masm32\include\windows.inc

Asc_Acima    	equ 48h       ; Up
Asc_Abaixo   	equ 50h       ; Down
Asc_Esquerda 	equ 4Bh       ; Left
Asc_Direita  	equ 4Dh       ; Right

Asc_PgUp     	equ 49h
Asc_PgDn     	equ 51h

Asc_Home     	equ 47h
Asc_End      	equ 4Fh

Asc_Insert   	equ 52h
Asc_Delete   	equ 53h
Asc_BackSpace     equ 08h
Asc_Return		equ 0Dh
Asc_Esc		equ 1Bh
;**********************************************************************************************
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc 
include \masm32\include\masm32.inc
; ---------------------------------------------------------------------------------------------
;                                       LIBRARIES
;
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
;-------------------------------------------------------------------------------------------
.data
                       dd 0
                       dd 200
  _EditorBuffer        db 200 dup (?)                    ; buffer to edit strings

                       dd 0
                       dd 200
  _AuxBuffer           db 200 dup (?)                    ; buffer to clean with spaces
; ---------------------------------------------------------------------------------------------
;                                   PASCAL \ RCL STRINGS
;
                       dd 15                              ; max = number inside
  _MsgErro0            db "Ocorreu um erro"               ; modified Pascal String 

                       dd 18                              ; max = number inside
  _MsgIni1             db "Press ENTER to end"            ; modified Pascal String 
;..................................................................................
                       dd 11                              ; max = number inside
  _MsgKeyEvent         db "Key Event  "                   ; modified Pascal String
                       dd 11                              ; max = number inside
  _MsgMouseEvent       db "Mouse Event"                   ; modified Pascal String
                       dd 11                              ; max = number inside
  _MsgSizeEvent        db "Size Event "                   ; modified Pascal String
                       dd 11                              ; max = number inside
  _MsgMenuEvent        db "Menu Event "                   ; modified Pascal String
                       dd 11                              ; max = number inside
  _MsgFocusEvent       db "Focus Event"                   ; modified Pascal String
                       dd 11                              ; max = number inside
  _MsgOtherEvent       db "Other Event"                   ; modified Pascal String 
;..........................................................   
                       dd 11                              ; max = number inside
  _MsgRepetition       db "Repetition:"                   ; modified Pascal String 

                       dd 12                               ; max = number inside
  _MsgReleased         db "Released    "                  ; modified Pascal String 
                       dd 12                              ; max = number inside
  _MsgReleased1        db "ret Released"                  ; modified Pascal String 
                       dd 12                               ; max = number inside
  _MsgPressed          db "Pressed     "                  ; modified Pascal String 

                       dd 19                              ; max = number inside
  _MsgInputRecRd       db "Input Records read:"           ; modified Pascal String
                       dd 21                              ; max = number inside
  _MsgInputRecUnRd     db "Input Records Unread:"           ; modified Pascal String 
   
                       ;
                       dd 0
                       dd 9
  _MsgCnvNumber        db 9 dup (?)
;..................................................................................
                       dd 20                              ; number inside
                       dd 20                              ; max
  _MsgIni2             db "Press RETURN to exit"          ; RCL String 

                       dd 23                              ; number inside
                       dd 50                              ; max
  _StrEdit1            db "Escreva qualquer coisa:"       ; RCL String 
                       db 27 dup (?)
;----------------------------------------------------------------------------------------------  
  _COLLINCur           dd 0                               ; current COL-1 (low) LIN-1 (high)
;----------------------------------------------------------------------------------------------
  _LastRecord          dd 0
                       dd 0
                       dd $MAXINPUTBUFFER
  _InputBuffer         db $MAXINPUTBUFFER * $LENINPUTRECORD dup(?) ; input buffer 40 records

                       dd 0
                       dd 300                           
  _PrintBuffer         db 300 dup (?)                     ; output buffer
;-----------------------------------------------------------------------------------------------
.data?
  _hInputBuffer	     dd ?                               ; input handle 
  _hScreenBuffer	     dd ?                               ; screen handle
;----------------------------------------------------------------------------------------------
.code 
start:       invoke  GetStdHandle, STD_INPUT_HANDLE     ; Get STANDARD INPUT BUFFER handle

	       cmp     eax, INVALID_HANDLE_VALUE	
	       je	  eStart
	       mov     _hInputBuffer, eax                 ; input buffer handle

             ;
             invoke  GetStdHandle, STD_OUTPUT_HANDLE    ; Get STANDARD SCREEN BUFFER handle

	       cmp     eax, INVALID_HANDLE_VALUE	
	       je      ibStart
	       mov     _hScreenBuffer, eax                ; screen buffer handle

             ; --------------------
             ; Print PASCAL message
             ; --------------------
             invoke   PASStrPrint, ADDR _MsgIni1, 1, 1

             ; ----------------------------------
             ; Edit string _StrEdit1 at (LIN,COL)
             ; ----------------------------------
             invoke  RCLEditStr, ADDR _StrEdit1, 10, 1
             jnc     short sbStart
;---------------------------------------------------------------------
;                             E N D
;---------------------------------------------------------------------         
_erro:      invoke  PASStrPrint, ADDR _MsgErro0 , 1, 1
            invoke  KeyWaitAny
            ;
            ; Wait a key
            ; ----------
sbStart:	invoke	CloseHandle, _hScreenBuffer          ; Close screen buffer	
ibStart:	invoke	CloseHandle, _hInputBuffer           ; Close input buffer

eStart:     invoke	ExitProcess, 0
; ==============================================
; The length of the RCL string goes from 0 to Max. The character position is controled by mean
; of IdxCur index (goes from 0 to IdxEnd = Max-1);
; Whenever _EditorBuffer receives one byte it is set in the palce [ _EditorBuffer+IdxCur ]
; 
; Action:
;        1- Prints RCL string pointed by pRCLStr and
;        2- Reads input buffer to it until Return
;
; Input:
;        pRCLStr - RCL string pointer 
;        nLin    - initial line
;        nCol    - initial column
;
; Uses:
;       _COLLINCur     = current cursor location
;       _hScreenBuffer = screen buffer handle
;       _hInputBuffer  = input buffer
;
RCLEditStr          proc   pRCLStr:DWORD, nLin:DWORD, nCol:DWORD
                    LOCAL  IdxEnd:DWORD                         ; last    index
                    LOCAL  IdxCur:DWORD                         ; current index
                    LOCAL  InsMode:DWORD                        ; mode: Sobre\Ins
                    ;
                    push   ebx 
                    push   esi

                    mov    InsMode, 0
                    mov    _LastRecord, 0
                    
                    ; ----------------------------
                    ; Copy RCLStr to _EditorBuffer 
                    ; ----------------------------
                    invoke  RCLCpyRCL, pRCLStr, ADDR _EditorBuffer
                    
                    ; --------------------
                    ; Complete with spaces
                    ; --------------------
                    mov     ebx, pRCLStr
                    mov     edx, dword ptr [ebx - 4]          ; Max
                    mov     al, 32
                    invoke  RCLAddFulAL, ADDR _EditorBuffer, edx
                    
                    ; ---------------------
                    ; Define IdxEnd, IdxCur
                    ; ---------------------
                    mov     ebx, pRCLStr
                    mov     ecx, dword ptr [ebx - 8]          ; Len
                    mov     edx, dword ptr [ebx - 4]          ; Max
                    ;
                    dec     edx
                    mov     IdxEnd, edx
                    ;
                    cmp     ecx, edx
                    jb      short _RCLEditStr00
                    ;
                    dec     ecx
                    ;
_RCLEditStr00:      mov     IdxCur, ecx
                    ;
                    ; --------------------
                    ; Print all RCL string
                    ; --------------------
_printALL:          invoke  RCLPrintAll, ADDR _EditorBuffer, nLin, nCol

                    ; ----------------------------
                    ; Position Cursor in (LIN,COL)
                    ; ----------------------------
_iRCLEditStr:       mov     ebx, offset _EditorBuffer
                    mov     ecx, dword ptr [ebx - 8]          ; Len
                    mov     eax, IdxCur
                    add     eax, nCol
                    ; ------------------
                    ; Read to AL, AH, DX
                    ; ------------------
                    invoke  CharRead, nLin, eax
                    jc      _rRCLEditStr

                    ; ---------
                    ; Filter AL
                    ; ---------
                    cmp     al, 0
                    je      short _iRCLEditStr1     ; control key
                    ;
                    cmp     al, Asc_BackSpace
                    je      _Exc_BackSpace
                    ;
                    cmp     al, Asc_Return
                    je      _oRCLEditStr

                    cmp     al, 20h
                    jb      _iRCLEditStr            ; Begin
                    jae     _Exc_NewChar            ; new char
                    
                    ; ------------
                    ; Control keys
                    ; ------------
_iRCLEditStr1:      cmp     ah, Asc_Esquerda        ; left
                    je      _Exc_Esquerda 	
                    cmp     ah, Asc_Direita         ; right 
                    je      _Exc_Direita 	
                    jne     short _iRCLEditStr      ; not control key
; ----------------------------------------------
_Exc_Esquerda: 	  mov     eax, IdxCur
                    cmp     eax, 0
                    je      _iRCLEditStr                 ; go back
                    ;
                    dec     IdxCur
                    jmp     _iRCLEditStr
; ----------------------------------------------
_Exc_Direita:       mov     eax, IdxCur
                    cmp     eax, IdxEnd
                    je      _iRCLEditStr                 ; go back
                    ;
                    inc     IdxCur
                    jmp     _iRCLEditStr
; ----------------------------------------------
_Exc_BackSpace:     mov     eax, IdxCur
                    cmp     eax, 0
                    je      _iRCLEditStr                 ; go back
                    ;
                    dec     eax
                    mov     IdxCur, eax
                    ;
                    invoke  RCLShlPos, ADDR _EditorBuffer, IdxCur
                    jmp    _printALL
; ---------------------------------------------------------------------------------------------
                    ; ------------------------------------
                    ; Puts AL into _EditorBuffer at IdxCur
                    ; ------------------------------------
_Exc_NewChar:       invoke  RCLPutBytAL, ADDR _EditorBuffer, IdxCur
                    ; ----------------
                    ; Print RCL string
                    ; ----------------
                    invoke  RCLPrintAll, ADDR _EditorBuffer, nLin, nCol
                    jmp    _Exc_Direita                                  ; Cursor right
                    ;
_rRCLEditStr:       stc                                                  ; error
_eRCLEditStr:       pop   esi 
                    pop   ebx
                    ret
                    ;
                    ; exit
                    ; ----
_oRCLEditStr:       clc                                                  ; OK
                    pop   esi 
                    pop   ebx
                    ret
RCLEditStr          endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Reads one key from InputBuffer
;
; Input:
;        Nothing        
;
; Output:
;       clc:
;           The key was pressed:
;
;           AL  - ascii code
;           AH  - char code
;           DX  - control code
;           CX  - repetitions
;  
;       stc:    ERROR
;
; Uses:
;       _hInputBuffer  = input buffer
;
CharRead            proc    nLin:DWORD, nCol:DWORD
                    push    ebx
                    ; ---------------
                    ; Potition cursor
                    ; ---------------
_iCharRead:         invoke  CursorSetPos, nLin, nCol
                    call    KeyWait
                    jnc     short _CharRead1                         ; There is 1 InputRecord         
                    ;
                    pop     ebx 
                    ret
                    ;
_CharRead1:         cmp     bx, TRUE
                    jne     short _CharRead2                         ; key was pressed
                    ;
                    ; key was released -> Clean InputBuffer
                    ; -------------------------------------
                    invoke   PASStrPrint, ADDR _MsgReleased1, 3, 40
                    invoke   FlushConsoleInputBuffer, _hInputBuffer
                    jmp     _iCharRead
                    ;
                    ; Get codes
                    ; ---------
_CharRead2:         mov     ecx, eax
                    invoke  RecordGet                               ; Get codes AL=ascii ...
                    ;
_eCharRead:         clc
                    pop     ebx
                    ret
CharRead            endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Wait for a key 
;
; Input:
;       nothing
;
; Output:
;       clc: key event
;               EDX - Event Type
;               ECX - Number of records read
;               EBX - Pressed / Released
;               EAX - Repeat Count
;
;       stc:    ERROR
;
; Uses:
;       _hInputBuffer  = input buffer
;
; Documentation:  ReadConsoleInput ( The function does not return until at least one record is 
;                                    available to be read )
;
KeyWait             proc

_iKeyWait:          invoke  ReadConsoleInput, _hInputBuffer,          
                                              ADDR _InputBuffer,       
                                              20,                        ; read 20
                                              ADDR _InputBuffer - 8 
                    cmp      eax, 0
                    jne      _KeyWait1                          ; not error         
                    stc
                    ret
                    
                    ; ---------------------
                    ; How many read records
                    ; ---------------------
_KeyWait1:          
                    push   esi
                        mov    esi, offset _InputBuffer
                        movzx  edx,  word ptr [esi + 0]          ; EventType
                        mov    ecx, dword ptr [esi - 8]          ; Number of records read
                        mov    ebx, dword ptr [esi + 2]          ; pressed\released
                        movzx  eax, word ptr  [esi + 6]          ; repeat count
                    pop    esi
                    ;
                    call   PrintEventTyp                ; Print Event type
                    call   PrintRecRead                 ; Print Number of records read
                    call   PrintNumRep                  ; Print Repeat count
                    call   PrintPresRel                 ; Print Pressed or Released
                    call   PrintNumPR                   ;   convert and print Press/Rel EBX
                    call   EventsUnRead                 ; Print unread Events
                    ;
                    cmp    ecx, 0
                    je     short _iKeyWait                      ; read 0
                    ;
                    cmp    edx, KEY_EVENT
                    jne    short _iKeyWait                      ; not key
                    ;
                    clc
                    ret
KeyWait             endp
; ---------------------------------------------------------------------------------------------
; the total number of unread input records in the input buffer, 
; including keyboard, mouse, and window-resizing input records
;
EventsUnRead        proc    
                    LOCAL   UnRead:DWORD
                    pushad
                        ;
                        invoke   GetNumberOfConsoleInputEvents, _hInputBuffer,
                                                                ADDR UnRead
                        ;
                        mov      eax, UnRead
                        invoke   DNatCnvRcl, ADDR _MsgCnvNumber 
                        invoke   PASStrPrint, ADDR _MsgInputRecUnRd, 5, 40
                        ;
                        invoke   RCLCleanMax, ADDR _MsgCnvNumber, 5, 62
                        invoke   RCLPrintLen, ADDR _MsgCnvNumber, 5, 62
                        ;                                         
                    popad
                    ret
EventsUnRead        endp
; ---------------------------------------------------------------------------------------------
KeyWaitAny          proc
                    ;
                    ; Clean input buffer
                    ; ------------------
                    invoke    FlushConsoleInputBuffer, _hInputBuffer
                    call      KeyWait
                    ret
KeyWaitAny          endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Get the Input Record
;
; Input:
;        Nothing        
;
; Output:
;           AL  - ascii code
;           AH  - char code
;           DX  - control  
;           EAX - control+char code+ascii code
;
RecordGet           proc    
                    mov     esi, offset _InputBuffer
                    movzx   edx, word ptr  [esi + 14]       ; Ascii Code
                    mov     ax,  word ptr  [esi + 12]       ; Char Code      PgUp,PgDn...
                    shl     ax, 8                           ; AH= Char code
                    mov     al, dl                          ; AL= Ascii code
                    movzx   edx,  word ptr [esi + 16]       ; ControlKeyState
                    ;
                    mov     ebx, eax
                    mov     ax, dx
                    shl     eax, 16
                    mov     ax, bx      ; EAX (high word=control) AX=Key code
                    ret
RecordGet           endp
; ---------------------------------------------------------------------------------------------
; Input:
;       ECX - number of records read
;
PrintRecRead        proc
                    pushad
                        ;
                        mov      eax, ecx
                        invoke   DNatCnvRcl, ADDR _MsgCnvNumber 
                        invoke   PASStrPrint, ADDR _MsgInputRecRd, 1, 40
                        ;
                        invoke   RCLCleanMax, ADDR _MsgCnvNumber, 1, 60
                        invoke   RCLPrintLen, ADDR _MsgCnvNumber, 1, 60
                        ;
                    popad
                    ret
PrintRecRead        endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EAX - Repetitions
;
PrintNumRep         proc
                    pushad
                        ;
                        invoke   DNatCnvRcl, ADDR _MsgCnvNumber 
                        invoke   PASStrPrint, ADDR _MsgRepetition, 4, 40
                        ;
                        invoke   RCLCleanMax, ADDR _MsgCnvNumber, 4, 52
                        invoke   RCLPrintLen, ADDR _MsgCnvNumber, 4, 52
                        ;
                    popad
                    ret
PrintNumRep         endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EDX - Event
;
; Output:
;       clc:    KEY
;
;       stc:    not KEY
;
PrintEventTyp       proc
                    pushad
                    ;
                    cmp     edx, KEY_EVENT
                    jne     short _PrintEventTyp1
                    ;
                    invoke   PASStrPrint, ADDR _MsgKeyEvent, 2, 40
                    clc
                    popad
                    ret
                    ;
_PrintEventTyp1:    cmp     edx, MOUSE_EVENT
                    jne     short _PrintEventTyp2

                    invoke   PASStrPrint, ADDR _MsgMouseEvent, 2, 40
                    stc
                    popad
                    ret
                    ;
_PrintEventTyp2:    cmp     edx, WINDOW_BUFFER_SIZE_EVENT
                    jne     short _PrintEventTyp3

                    invoke   PASStrPrint, ADDR _MsgSizeEvent, 2, 40
                    stc
                    popad
                    ret
                    ;
_PrintEventTyp3:    cmp     edx, MENU_EVENT
                    jne     short _PrintEventTyp4

                    invoke   PASStrPrint, ADDR  _MsgMenuEvent, 2, 40
                    stc
                    popad
                    ret
                    ;
_PrintEventTyp4:    cmp     edx, FOCUS_EVENT
                    jne     short _PrintEventTyp5

                    invoke   PASStrPrint, ADDR _MsgFocusEvent, 2, 40
                    stc
                    popad
                    ret

_PrintEventTyp5:    invoke   PASStrPrint, ADDR _MsgOtherEvent, 2, 40
                    stc
                    popad
                    ret
PrintEventTyp       endp
; ---------------------------------------------------------------------------------------------
; Input:
;       EBX  - True/False 
;
; Output:
;       clc:    Pressed
;
;       stc:    Released
;
PrintPresRel        proc
                    pushad
                    ;
                    cmp     ebx, TRUE
                    jne     short _PrintPresRel1
                    ;
                    invoke   PASStrPrint, ADDR _MsgPressed, 3, 40
                    clc
                    popad
                    ret
                    ;
_PrintPresRel1:     invoke   PASStrPrint, ADDR _MsgReleased, 3, 40
                    stc
                    popad
                    ret
PrintPresRel        endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Convert and Print pressed/released value in EBX in hexadecimal
;
; Input:
;       EBX - 
;
PrintNumPR          proc
                    pushad
                        ;
                        mov      eax, ebx
                        invoke   DHexCnvRcl, ADDR _MsgCnvNumber
                        invoke   RCLCleanMax, ADDR _MsgCnvNumber, 3, 52
                        invoke   RCLPrintLen, ADDR _MsgCnvNumber, 3, 52
                        ;
                    popad
                    ret
PrintNumPR          endp
; 
;                                   RCL FUNCTIONS
; ---------------------------------------------------------------------------------------------
; p   means pointer;  l  means length
; RCL means strings of the type:         
;                                           dd Len              ; - 8
;                                           dd Max              ; - 4
;                               addressRCL  db Max dup (?)
;
;...............................................................................
; In RCL strings, whenever possible:
;                EBX    - initial address
;                ECX    - length = number of bytes in the buffer
;                EDX    - max number of bytes
;
;...............................................................................
; Action:
;        Print the RCL string pointed by pRCLStr
;
; Input:
;       pRCLStr - RCL string pointer
;       nLIN    -
;       nCOL    -
;
; Info:
;       _COLLINCur    = current cursor location
;       _hScreenBuffer = screen buffer handle
;
RCLPrintLen         proc    pRCLStr:DWORD, nLIN:DWORD, nCOL:DWORD
                    push    ebx
                    ;
                    invoke  CursorSetPos, nLIN, nCOL
                    mov     ebx, pRCLStr
                    mov     ecx, dword ptr [ebx - 8]
                    cmp     ecx, 0
                    je      _eRCLPrintLen
                    ;
                    invoke  WriteConsole, _hScreenBuffer,       ; handle
                                          pRCLStr,              ; print buffer
                                          ecx,                  ; write ECX char
                                          eax,                  ; Number written
                                          0                     ;
_eRCLPrintLen:      pop ebx
                    ret
RCLPrintLen         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Print the RCL string pointed by pRCLStr
;
; Input:
;       pRCLStr  - RCL string pointer
;        nLin    - initial line
;        nCol    - initial column
;
; Info:
;       _COLLINCur     = current cursor location
;       _hScreenBuffer = screen buffer handle
;
RCLCleanMax         proc    pRCLStr:DWORD, nLin:DWORD, nCol:DWORD
                    push    ebx
                    push    edi
                    ;
                    mov     ebx, pRCLStr
                    mov     ecx, dword ptr [ebx - 4]
                    ;
                    ; Set _AuxBuffer with Len chars 20h
                    ; ---------------------------------
                    mov     edi, offset _AuxBuffer
                    cmp     ecx, dword ptr [edi - 4]
                    jbe     short _RCLCleanMax1
                    ;
                    mov     ecx, dword ptr [edi - 4]
                    ;
_RCLCleanMax1:      mov     dword ptr [edi - 8], ecx
                    ;
                    mov     al, 20h
                    cld
                    rep     stosb
                    ;
                    invoke  RCLPrintLen, ADDR _AuxBuffer, nLin, nCol
                    ;
_eRCLCleanMax:      pop     edi 
                    pop     ebx
                    ret
RCLCleanMax         endp
;----------------------------------------------------------------------------------------------
; Action:
;        Print all RCL string pointed by pRCLStr
;
; Input:
;       pRCLStr - RCL string pointer
;       nLIN    -
;       nCOL    -
;
; Info:
;       _COLLINCur    = current cursor location
;       _hScreenBuffer = screen buffer handle
;
RCLPrintAll         proc    pRCLStr:DWORD, nLIN:DWORD, nCOL:DWORD
                    push    ebx
                    ;
                    invoke  CursorSetPos, nLIN, nCOL
                    mov     ebx, pRCLStr
                    mov     ecx, dword ptr [ebx - 4]
                    cmp     ecx, 0
                    je      _eRCLPrintAll
                    ;
                    invoke  WriteConsole, _hScreenBuffer,       ; handle
                                          pRCLStr,              ; print buffer
                                          ecx,                  ; write ECX char
                                          eax,                  ; Number written
                                          0                     ;
_eRCLPrintAll:      pop ebx
                    ret
RCLPrintAll         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Add byte given in AL to RCL string pointed by EDI
;
; Input:
;       AL      - byte
;       pRCLStr - string pointer
;
; Info:
;       clc:    byte added
;       stc:    string is full
;
RCLAddBytAL         proc    pRCLStr:DWORD
                    push    ebx
                    push    edi
                    ;
                    mov     edi, pRCLStr
                    mov     ebx, edi
                    mov     ecx, dword ptr [ebx - 8]        ; Len
                    mov     edx, dword ptr [ebx - 4]        ; Max
                    cmp     ecx, edx
                    jb      short _iRCLAddBytAL
                    ;
                    stc
                    jc      short _eRCLAddBytAL
                    ;
_iRCLAddBytAL:      add     edi, ecx
                    mov     byte ptr [edi], al
                    ;
                    inc     ecx
                    mov     dword ptr [ebx - 8], ecx
                    clc
                    ;
_eRCLAddBytAL:      pop edi
                    pop ebx
                    ret
RCLAddBytAL         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Add byte given in AL to RCL string pointed by EDI
;
; Input:
;       AL      - byte
;       pRCLStr - string pointer
;       lMax    - len max
;
; Info:
;       clc:    byte added
;       stc:    string is full
;
RCLAddFulAL         proc    pRCLStr:DWORD, lMax:DWORD   
                    push    ebx
                    push    edi
                    ;
                    mov     ebx, pRCLStr
                    mov     ecx, dword ptr [ebx - 8]        ; Len
                    mov     edx, lMax
                    ;
                    cmp     edx, dword ptr [ebx - 4]        ; Max
                    jbe     short _iRCLAddFulAL0
                    ;
                    mov     edx, dword ptr [ebx - 4]        ; Max
                    ;
_iRCLAddFulAL0:     cmp     ecx, edx
                    jb      short _iRCLAddFulAL
                    ;
                    stc
                    jc      short _eRCLAddFulAL
                    ;
_iRCLAddFulAL:      mov     edi, ebx
                    add     edi, ecx
                    xchg    ecx, edx
                    sub     ecx, edx
                    ;
                    cld
                    rep     stosb
                    clc
                    ;
_eRCLAddFulAL:      pop edi
                    pop ebx
                    ret
RCLAddFulAL         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the byte given in AL to RCL string pointed by pRCLStr at the position iPos
;
; Input:
;       AL      - byte
;       pRCLStr - string pointer
;       iPos    - position (0,1,2,...)
;
; Info:
;       clc:    byte added
;       stc:    string is full
;
RCLPutBytAL         proc    pRCLStr:DWORD, iPos:DWORD
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     edi, pRCLStr
                    mov     esi, edi
                    mov     ebx, iPos
                    ;
                    mov     ecx, dword ptr [esi - 8]        ; Len
                    mov     edx, dword ptr [esi - 4]        ; Max
                    ;
                    cmp     ebx, edx
                    jb      short _iRCLPutBytAL
                    ;
                    stc
                    jc      short _eRCLPutBytAL
                    ;
_iRCLPutBytAL:      mov     byte ptr [edi + ebx], al
                    ;
                    cmp     ebx, ecx
                    jb      short _RCLPutBytAL1
                    
                    inc     ebx
                    mov     dword ptr [esi - 8], ebx
_RCLPutBytAL1:      clc
                    ;
_eRCLPutBytAL:      pop   edi
                    pop   esi
                    pop   ebx
                    ret
RCLPutBytAL         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Copys string RCLStr1 to string RCLStr2 
;
; Input:
;       pRCLStr1 - string pointer 
;       pRCLStr2 - string pointer to where copy
;
; Info:
;
RCLCpyRCL           proc    pRCLStr1:DWORD, pRCLStr2:DWORD 
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     ebx, pRCLStr2
                    mov     edi, ebx
                    mov     edx, dword ptr [ebx - 4]        ; Max Str DST
                    ;
                    mov     esi, pRCLStr1
                    mov     ecx, dword ptr [esi - 8]        ; Len Str FNT
                    ;
                    cmp     ecx, edx
                    jbe     short _iRCLCpyRCL
                    ;
                    mov     ecx, edx
                    ;
_iRCLCpyRCL:        or      ecx, ecx
                    jz      short _iRCLCpyRCL1
                    ;
                    cld
                    rep     movsb
                    ;
_iRCLCpyRCL1:       invoke  RCLSetLen
                    ;
_eRCLCpyRCL:        pop   edi
                    pop   esi
                    pop   ebx
                    ret
RCLCpyRCL           endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Shift left the string pointed by pRCLStr to the position iPos
;
; Input:
;       pRCLStr - string pointer
;       iPos    - position (0,1,2,...)
;
; Info:
;       clc:    string shifted
;       stc:    iPos > Max
;
RCLShlPos           proc    pRCLStr:DWORD, iPos:DWORD
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     edi, pRCLStr
                    mov     esi, edi
                    mov     ebx, iPos
                    ;
                    mov     ecx, dword ptr [esi - 4]        ; Max
                    ;
                    cmp     ebx, ecx
                    jb      short _iRCLShlPos
                    ;
                    stc
                    jc      short _eRCLShlPos
                    ;
_iRCLShlPos:        add     ecx, edi
                    ;
                    add     edi, ebx
                    mov     ebx, esi
                    ;
                    mov     esi, edi
                    inc     esi
                    ;
                    sub     ecx, esi
                    ;
                    cld
                    rep     movsb
                    ;
                    mov     byte ptr [edi], 32
                    ;
                    invoke  RCLSetLen
                    ;
_eRCLShlPos:        pop   edi
                    pop   esi
                    pop   ebx
                    ret
RCLShlPos           endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Fills the string pointed by pRCLStr with byte AL
;
; Input:
;       AL      - byte
;       pRCLStr - string pointer
;
; Info:
;
RCLFilBytAL         proc    pRCLStr:DWORD
                    push    ebx
                    push    edi
                    ;
                    mov     ebx, pRCLStr
                    mov     edi, ebx
                    mov     ecx, dword ptr [ebx - 4]        ; Max
                    ;
                    mov     dword ptr [ebx - 8], ecx        ; Len
                    xor     ebx, ebx
                    ;
_iRCLFilBytAL:      mov     byte ptr [edi + ebx], al
                    inc     ebx
                    loop    short _iRCLFilBytAL
                    ;
_eRCLFilBytAL:      pop   edi
                    pop   ebx
                    ret
RCLFilBytAL         endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Cleans the string pointed by pRCLStr with spaces
;
; Input:
;       pRCLStr - string pointer
;
RCLClean            proc    pRCLStr:DWORD
                    mov     al, 32
                    invoke  RCLFilBytAL, pRCLStr
                    ret
RCLClean            endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the length of the string pointed by EBX
;
; Input:
;       EBX     - string pointer
;       EDI     - position after the last byte in the string
;
; Output:
;       clc
;
RCLSetLen           proc
                    sub     edi, ebx
                    mov     dword ptr [ebx - 8], edi
                    clc
                    ret
RCLSetLen           endp
; 
;                                   CONVERSION FUNCTIONS
;----------------------------------------------------------------------------------------------
; Action:
;	    Converte a Dword natural em EAX em dgitos ASCII naturais
;         ( 0-9 ) que coloca na string de tipo RCL apontada por
;	    por EDI
;
; Input:
;	    EAX  	- Dword a converter em ASCII
;	    pRclStr	- Endereo da string de tipo RCL
;
; Output:
;	    clc:   N in the string
;
;	    stc:   No cabe na string => overflow ( ********** )
;
; Info:
;		Preserva todos os registos
;
DNatCnvRcl		proc  pRclStr:DWORD
			pushad
			;
			; Divide EAX por 10 e coloca no stack
			; -----------------------------------
                  mov    edi, pRclStr
			mov	 esi, 10
			call	 near ptr EAXStkCnv

			; **********************************
			; Retira do stack e coloca na string
			; ----------------------------------
			call	 near ptr RCLStkCpy
			;
                  popad
			ret
DNatCnvRcl		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	  Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;       ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;		EAX    - Dword a converter em ASCII hexadecimal
;		EDI 	 - Endereo da string
;
; Output:
;           clc: OK
;           stc:
;
DHexCnvRcl		proc	pRclStr:DWORD
			pushad
			;
                  mov    edi, pRclStr
			cmp	dword ptr [edi - 4], 8
			jae	short _DHexCnvRcl1
                  ;
                  stc
			popad
			ret
			;
_DHexCnvRcl1:     mov	ebx, edi
			call	near ptr DHexCnvBuf
			call	near ptr RCLSetLen
			;
                  popad
			ret
DHexCnvRcl		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	    Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;         ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;	    EAX  - Dword a converter em ASCII hexadecimal
;	    EDI  - buffer address
;
; Info:
;	    Deixa EDI no fim
;
DHexCnvBuf		proc
			push	ebx
			;
			; Divide EAX by 16 and put on the stack
			; -------------------------------------
			mov	esi, 16
			call	 near ptr EAXStkCnv
			;
			; Take from stack put into buffer EDI
			; -----------------------------------
			mov   ebx, 8
			mov	ah, 30h
			call	near ptr BufStkCpy
			;
			pop	ebx
			ret
DHexCnvBuf		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	   Divide EAX by ESI and put each ascii code on the Stack.
;        Used in conversion to binary, decimal and hexa 
;
; Input:
;	   EAX  - N a dividir
;        ESI  - N pelo qual divide
;
; Output:
;	   ECX  - N of bytes on the stack
;        ESP  - Point to the TOP of the stack where is the most significant byte (digit)
;
; Info:
;	   Destroi EAX, EDX, EBP
;
EAXStkCnv         proc	near
			pop	ebp			; Remove do stack o endereo de retorno
			;
			xor	edx, edx
			xor	ecx, ecx
			;
			or	eax, eax
			jz	short _EAXStkCnv2
			;
_EAXStkCnv1:  	xor	edx, edx
			div   esi		      ; divide EDX:EAX por ESI e coloca o quociente
_EAXStkCnv2:	add   edx, 30h          ; em EAX e o resto em EDX e soma 30h
			;
			cmp	edx, 3Ah
			jb	short _EAXStkCnv3
			;
			add	edx, 7
			;
_EAXStkCnv3:	push  edx          	; to stack
			inc	ecx          	; one more
			;
			and	eax, eax
			jnz  	short _EAXStkCnv1
			;
			push	ebp               ; Restore the return address
			ret
EAXStkCnv		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	    Retira do stack ECX bytes e coloca no buffer apontado por EDI
;         Sai com EDI apontando o fim do buffer e ECX n de bytes colocados
;
; Input:
;	   ECX   - N de bytes no stack
;        EDI   - Ponteiro string RCL
;
; Output:
;	   clc:    N na string
;
;	   stc:    No cabe na string => overflow ( ********** )
;
;
; Info:
;	   Usa e destroi EBX
;
RCLStkCpy         proc
			pop	 ebp                 ; Remove do stack o endereo de retorno
			;
			; Coloca 0 na string
			; ------------------
                  mov    ebx, edi
                  mov    edx, dword ptr [ebx - 4]         ; Max
			mov	 dword ptr [ebx - 8], 1           ; Len
			mov	 byte ptr [edi], '0'
			;
			; H dgitos ?
			; ------------
                  cmp    ecx, 0
			jz	 short _eRCLStkCpy
			;
			; Cabe na string ?
			; ----------------
			cmp	 ecx, edx
			jbe	 short _RCLStkCpy1					; cabe
			;
			; No cabe -> Retira os ECX bytes do stack e discard
			; ---------------------------------------------------
_RCLStkCpy0:	pop	 eax
			loop   short _RCLStkCpy0

			; ************
			; Set OVERFLOW 
			; ------------
                  mov	 dword ptr [ebx - 8], edx
			;
			mov	 ecx, edx
			mov	 al, '*'
                  cld
			rep    stosb
			;
			stc
			push	ebp
			ret
;.............................................................................
			; **************
			; Set the length
			; --------------
_RCLStkCpy1:      mov     dword ptr [ebx - 8], ecx
			;
			; Retira do stack e coloca no buffer RCL
			; --------------------------------------
_RCLStkCpy2:	pop	 eax
                  mov    byte ptr [edi], al
			inc    edi
			loop   short _RCLStkCpy2
			;
_eRCLStkCpy:	clc
                  push	ebp              ; Restore the return address
			ret
RCLStkCpy		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	   Retira do stack ECX bytes e coloca no buffer apontado por EDI
;
; Input:
;	   ECX   - N de bytes no stack
;        EBX   - Comprimento mximo ( acrescenta AH no incio )
;	   AH	   - Caracter a acrescentar no incio
;        EDI   - Ponteiro inicial da string
;
; Output:
;	   EDI   - Aponta para o fim
;
BufStkCpy		proc
			pop	ebp
			;
			cld
			cmp	ecx, ebx
			jbe	short _BufStkCpy0
			;
			; Retira do stack ECX - EBX
			; -------------------------
			sub	ecx, ebx
			shl	ecx, 2
			add	esp, ecx
			;
			mov	ecx, ebx
			;
_BufStkCpy0:     	sub	ebx, ecx
			jz    short _BufStkCpy1
			;
			push	ecx
				mov	ecx, ebx
				mov	al, ah
				rep	stosb
			pop	ecx
			;
_BufStkCpy1:	pop	eax
			stosb
			loop  short _BufStkCpy1
			;
			push	ebp
			ret
BufStkCpy		endp
; 
;                                   PASCAL FUNCTIONS
; ---------------------------------------------------------------------------------------------
; Action:
;        Prints the Pascal string pointed by pPASStr
;
; Input:
;       pPASStr  - Pascal string pointer
;        nLin    - initial line
;        nCol    - initial column
;
; Info:
;       _COLLINCur     = current cursor location
;       _hScreenBuffer = screen buffer handle
;
PASStrPrint         proc    pPASStr:DWORD, nLIN:DWORD, nCOL:DWORD
                    LOCAL   wRCLStr:DWORD
                    pushad
                    ;
                    invoke  LCCurSet, nLIN, nCOL
                    ;
                    mov     ebx, dword ptr pPASStr
                    mov     ecx, dword ptr [ebx - 4]
                    invoke  WriteConsoleOutputCharacter, _hScreenBuffer,    ; handle
                                                         pPASStr,           ; print buffer
                                                         ecx,               ; write N char
                                                         _COLLINCur,        ; COL + LIN (word)
                                                         ADDR wRCLStr 
                    ;
                    popad
                    ret
PASStrPrint         endp
; 
;                                       C U R S O R
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the COL and LIN in the variable _COLLINCur and put the cursor at that position 
;
; Input:
;       nLIN  - line
;       nCOL  - column
;
; Info:
;       _COLLINCur = LIN+COL dword
;
CursorSetPos        proc    nLin:DWORD, nCol:DWORD
                    ;
                    invoke  LCCurSet, nLin, nCol
                    invoke  SetConsoleCursorPosition, _hScreenBuffer, _COLLINCur
                    ;
                    ret
CursorSetPos        endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the COL and LIN in the variable _COLLINCur
;
; Input:
;       nLin  - line
;       nCol  - column
;
; Info:
;       _COLLINCur = LIN+COL dword
;
LCCurSet            proc  nLin:DWORD, nCol:DWORD
                    push  ebx
                    ;
                    mov   ebx, offset _COLLINCur
                    mov   eax, nCol
                    mov   edx, nLin
                    dec   ax
                    dec   dx
                    mov   word ptr [ebx + 0], ax
                    mov   word ptr [ebx + 2], dx
                    ;
                    pop   ebx
                    ret
LCCurSet            endp
; 
END start

